#
# Spec file for NVIDIA kernel module.
#
# $Header: //sw/linux/main/NVIDIA_kernel.spec#48 $
#
%define RELEASE 3
%define rel	%{?CUSTOM_RELEASE} %{!?CUSTOM_RELEASE:%RELEASE}
%define ver     0.9

Summary: NVIDIA kernel module for NVIDIA Architecture support.
Name: 		NVIDIA_kernel
Version: 	%ver
Release: 	%rel
Copyright: 	NVIDIA Corp. 2000
Group: 		User Interface/X Hardware Support
Source: 	ftp://ftp1.detonator.nvidia.com/pub/drivers/english/XFree86_40/NVIDIA_kernel-%{ver}-%{RELEASE}.tar.gz
URL: 		http://www.nvidia.com
Vendor: 	NVIDIA Corp.
BuildRoot: 	/var/tmp/%{name}-%{PACKAGE_VERSION}
Packager: 	Buildmeister
Requires:	kernel >= 2.2.0

%description
NVIDIA Architecture support for Linux kernel 2.2.X

%prep
%setup -q -n ${RPM_PACKAGE_NAME}-${RPM_PACKAGE_VERSION}-${RPM_PACKAGE_RELEASE}


%build
make NVdriver

# This will install the module itself onto the user's system, but not 
# load it into the running system. This will allow our auto-builds to
# execute properly
%install
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && rm -rf $RPM_BUILD_ROOT
    mkdir -p $RPM_BUILD_ROOT/lib/modules/`uname -r`/video
    install NVdriver $RPM_BUILD_ROOT/lib/modules/`uname -r`/video

%clean 
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && rm -rf $RPM_BUILD_ROOT

# In %post we basically do "run-time" installation
# Note that our files are installed onto the system, and the packages
# are cleaned up and gone. There are no Makefiles or fancy environment
# variables to play with. I basically repeated the needed parts of the
# install.sh script here
%post

    # unload it quietly if already loaded..
    /sbin/rmmod NVdriver >/dev/null 2>&1

    # Load the driver to get the major device numbers.
    /sbin/insmod /lib/modules/`uname -r`/video/NVdriver 

    # Read device major numbers.
    set -- `cat /proc/devices | grep --word-regexp nvidia`
    nvnode=$1

    # Create device nodes.
    for d in 0 1 2 3 
    do
        devfile=/dev/nvidia$d
        rm -f $devfile
        mknod $devfile c 195 $d
        chmod 0666 $devfile
    done

    devfile=/dev/nvidiactl
    rm -f $devfile
    mknod $devfile c $nvnode 255
    chmod 0666 $devfile

    # Automatically load the kernel module using kmod
    # Add our line to /etc/conf.modules (after first deleting any 
    # older NVdriver lines)

    confmod="/etc/conf.modules"
    [ -f /etc/modules.conf ] && confmod="/etc/modules.conf"

    conftmp=/tmp/conf$$

    sed '/^alias.*char-major-.*NVdriver/d' < $confmod > $conftmp
    echo "alias char-major-$nvnode NVdriver" >> $conftmp
    mv $conftmp $confmod

    # Add it to the module dependency list.
    /sbin/depmod -a

    # It worked
    echo
    echo NVdriver installed successfully
    echo

    exit 0

%preun
if [ $1 = 0 ] ; then
    #
    # unload it quietly if already loaded..
    #
    if [ -n "`/sbin/lsmod | grep NVdriver`" ]; then
        /sbin/rmmod NVdriver >/dev/null 2>&1
    fi
fi

%files
%attr(- root root) /lib/modules/*/video/NVdriver

%changelog
* Tue May 02 2000 Terence Ripperda <tripperda@nvidia.com>
- regress use of "make install" in post, no Makefile present

* Fri Apr 27 2000 Nick Triantos <nick@nvidia.com>
- Use "NVdriver" and "install" targets on make
- Remove BuildReq item from header, was causing build error

* Thu Apr 27 2000 Gregory McLean <gregm@comstar.net>
- Cleaned out some redundant parts of the spec file.
- Set the buildroot.
- Made sure the preun gets called properly.
- Added a %clean section to keep building machine tidy.
- Set up logic for epoc builds if needed.

